function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);

	//LD-8267 - Added a condition to avoid tracking null/empty data unnecessarily
	if (hexString.length > 0 || (myTop.suspendDataCache && myTop.suspendDataCache.indexOf('VarTrivBtnTracking') >= 0) || !this.VarTrivBtnTracking.bSCORM)
		this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'inside_financial_services_regulation_citi', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:655155,v:'normalState'},{id:47849,v:'normalState'},{id:50838,v:'normalState'},{id:50845,v:'normalState'},{id:50859,v:'normalState'},{id:265103,v:'normalState'},{id:52029,v:'normalState'},{id:58646,v:'normalState'},{id:598617,v:'normalState'},{id:176645,v:'normalState'},{id:293612,v:'normalState'},{id:575907,v:'normalState'},{id:792169,v:'normalState'},{id:792160,v:'normalState'},{id:1155532,v:'normalState'},{id:1155552,v:'normalState'},{id:1155573,v:'normalState'},{id:1155610,v:'normalState'},{id:720758,v:'normalState'},{id:720746,v:'normalState'},{id:720722,v:'normalState'},{id:720710,v:'normalState'},{id:720698,v:'normalState'},{id:802069,v:'normalState'},{id:1323601,v:'normalState'},{id:1323610,v:'normalState'},{id:1323802,v:'normalState'},{id:1323813,v:'normalState'},{id:1323824,v:'normalState'},{id:1323835,v:'normalState'},{id:1323850,v:'normalState'},{id:1323864,v:'normalState'},{id:1323878,v:'normalState'},{id:1323897,v:'normalState'},{id:1323939,v:'normalState'},{id:1323947,v:'normalState'},{id:1326915,v:'normalState'},{id:1326929,v:'normalState'},{id:1326943,v:'normalState'},{id:1326878,v:'normalState'},{id:1326889,v:'normalState'},{id:1326900,v:'normalState'},{id:1156962,v:'normalState'},{id:1157006,v:'normalState'},{id:1324670,v:'normalState'},{id:1324688,v:'normalState'},{id:1324705,v:'normalState'},{id:1324721,v:'normalState'},{id:1324738,v:'normalState'},{id:1324754,v:'normalState'},{id:1324770,v:'normalState'},{id:1324786,v:'normalState'},{id:1324802,v:'normalState'},{id:1324819,v:'normalState'},{id:1324835,v:'normalState'},{id:1327282,v:'normalState'},{id:1327293,v:'normalState'},{id:1327304,v:'normalState'},{id:1327315,v:'normalState'},{id:1359875,v:'normalState'},{id:1360129,v:'normalState'},{id:1327331,v:'normalState'},{id:1327364,v:'normalState'},{id:1327380,v:'normalState'},{id:1327403,v:'normalState'},{id:1327419,v:'normalState'},{id:1355440,v:'normalState'},{id:1355456,v:'normalState'},{id:1355477,v:'normalState'},{id:1355491,v:'normalState'},{id:1355897,v:'normalState'},{id:1355913,v:'normalState'},{id:1355935,v:'normalState'},{id:1355950,v:'normalState'},{id:1327451,v:'normalState'},{id:1327466,v:'normalState'},{id:1327490,v:'normalState'},{id:1327506,v:'normalState'},{id:1361760,v:'normalState'},{id:1361776,v:'normalState'},{id:1361797,v:'normalState'},{id:1361811,v:'normalState'},{id:1362189,v:'normalState'},{id:1362205,v:'normalState'},{id:1362227,v:'normalState'},{id:1362242,v:'normalState'},{id:1325505,v:'normalState'},{id:1325521,v:'normalState'},{id:1325535,v:'normalState'},{id:1325471,v:'normalState'},{id:1325481,v:'normalState'},{id:1325491,v:'normalState'},{id:1325613,v:'normalState'},{id:1377811,v:'normalState'},{id:1378923,v:'normalState'},{id:1380651,v:'normalState'},{id:1243226,v:'normalState'},{id:1243240,v:'normalState'},{id:1243254,v:'normalState'},{id:1244592,v:'normalState'},{id:1319604,v:'normalState'},{id:1400677,v:'normalState'},{id:1402473,v:'normalState'},{id:1403394,v:'normalState'},{id:1326177,v:'normalState'},{id:1326191,v:'normalState'},{id:1405576,v:'normalState'},{id:1405587,v:'normalState'},{id:1405598,v:'normalState'},{id:1405617,v:'normalState'},{id:1405635,v:'normalState'},{id:1408849,v:'normalState'},{id:1408860,v:'normalState'},{id:1408871,v:'normalState'},{id:1408890,v:'normalState'},{id:1408908,v:'normalState'},{id:1326301,v:'normalState'},{id:1326345,v:'normalState'},{id:1327052,v:'normalState'},{id:1327061,v:'normalState'},{id:1327070,v:'normalState'},{id:1327092,v:'normalState'},{id:1327104,v:'normalState'},{id:1327116,v:'normalState'},{id:1326442,v:'normalState'},{id:1326464,v:'normalState'},{id:70221,v:'normalState'},{id:194542,v:'normalState'},{id:294732,v:'normalState'},{id:321023,v:'normalState'},{id:321015,v:'normalState'},{id:1025256,v:'normalState'},{id:1025270,v:'normalState'},{id:1025142,v:'normalState'},{id:1025156,v:'normalState'},{id:1055301,v:'normalState'},{id:1055315,v:'normalState'},{id:323733,v:'normalState'},{id:323725,v:'normalState'},{id:323409,v:'normalState'},{id:323401,v:'normalState'},{id:788049,v:'normalState'},{id:788063,v:'normalState'},{id:1055430,v:'normalState'},{id:1055444,v:'normalState'},{id:923576,v:'normalState'},{id:923590,v:'normalState'},{id:325221,v:'normalState'},{id:325757,v:'normalState'},{id:329044,v:'normalState'},{id:327409,v:'normalState'},{id:1429833,v:'normalState'},{id:1429842,v:'normalState'},{id:1429851,v:'normalState'},{id:1429860,v:'normalState'},{id:1429979,v:'normalState'},{id:233645,v:'normalState'},{id:233637,v:'normalState'},{id:590305,v:'normalState'},{id:590317,v:'normalState'},{id:673002,v:'normalState'},{id:674262,v:'normalState'},{id:590337,v:'normalState'},{id:590345,v:'normalState'},{id:233060,v:'normalState'},{id:233308,v:'normalState'},{id:135253,v:'normalState'},{id:234172,v:'normalState'},{id:233847,v:'normalState'},{id:233839,v:'normalState'},{id:69966,v:'normalState'}]};
